#!/usr/bin/python
#
# minspeed.py
#
# Copyright 2017 William Henning
#
# Web site: http://Mikronauts.com
#
# Python utility for finding:
#
# minimum RPM a motor will turn at
#
# RON at min/255 of motor supply voltage
# RPM at 100/255 of motor supply voltage
# RPM at 122/255 of motor supply voltage
# RPM at 255/255 of motor supply voltage
#
# Please note you have to account for all voltage losses
#
# VBat = battery pack voltage
# VMotor = VBat - (Vprot + Vdriver) for voltage protection diode and motor driver loss
# VMotor = VBat - (0.7V + ~0.7V)
# 
# So with a 6V battery pack, the motor will only get about 4.6V

import RoboPiLib as RoboPi
import time as time

RoboPi.RoboPiInit("/dev/serial0",115200)

print RoboPi.getProductID()

print "DC Gear motor RPM tester"

p = 0
pulses = 0
loops = 0
lc = 0
motor = 0

A = 8 # front starboard rev
B = 9 # front starboard fwd

tach  = 16

motor = A

RoboPi.pinMode(A,RoboPi.OUTPUT)
RoboPi.pinMode(B,RoboPi.OUTPUT)
RoboPi.analogWrite(A,0)
RoboPi.analogWrite(B,0)

time.sleep(1)

minspeed = 255

for speed in range(0,20):

  RoboPi.analogWrite(motor,speed*5)
  started = time.time()
  ends = started + 2.0
  
  print "Testing minimum speed ",speed*5
  
  while (time.time() < ends):
     if (RoboPi.digitalRead(tach)):
        minspeed = speed*5
        break
        
  if minspeed < 255:
     break   

RoboPi.analogWrite(A,0)
RoboPi.analogWrite(B,0)

RoboPi.analogWrite(motor,minspeed)

print "Minimum speed is", minspeed

time.sleep(5)

for speed in [100, 122, 255]:

  RoboPi.analogWrite(A,0)
  RoboPi.analogWrite(B,0)
  RoboPi.analogWrite(motor,speed)
  time.sleep(1)
  started = time.time()

  while 1:
    l = p
    p = RoboPi.digitalRead(tach)
    if (p == 1) and (l == 0):
      pulses +=  1
      now = time.time()-started
      if (now > 59.99): 
        started = time.time()
        print speed, pulses #, "RPM"
        pulses = 0
        break

RoboPi.analogWrite(motor,0)
RoboPi.RoboPiExit()

